#  Copyright (c) 2019 Jeorme Douay <jerome@far-out.biz>
#  MIT Liecnce, see the licence file for more information.

from scipy.interpolate import interp1d

class Gearbox(object):
    '''
    Gearbox class to maanage gearbox attribute
    '''
    def __init__(self):
        '''
        Initialisation : gearbox ratio per gear is initialised
        '''
        super().__init__()
        self.ratio=interp1d([1,2,3,4,5],[10,9,8,7,6])

    def Ratio(self,gear):
        '''
        Return the gear ratio for a given gear
        :param gear: gear number
        :return: gear ratio
        '''
        return self.ratio(gear)
