import pandas

from pyPowerTrain.trigger import Trigger

class Shift(object):
    '''
    Generate Table bevore and after shifting
    '''

    def __init__(self):
        super().__init__()
        self.pre = Trigger()
        self.post = Trigger()
        
        self.preup=True
        self.postup=False

    def SetPre(self, names):
        self.pre.Set(names)

    def SetPost(self, names):
        self.post.Set(names)

    def SetTriggerPre(self, name):
        self.pre.SetTrigger(name,self.preup)

    def SetTriggerPost(self, name):
        self.post.SetTrigger(name,self.postup)

    def Change(self, name, data):
        dest = "%s_mod" % (name)
        data[dest] = data[name].shift(-1) - data[name]
        data.dropna()

    def Process(self, data): #, filename):
        pre=self.pre.Process(data)
        pre['time_pre'] = pre.index
        post=self.post.Process(data)
        post['time_post'] = post.index

        results = pandas.concat([pre, post], axis=1)
        for col in post.columns:
            results[col].fillna(method='bfill', inplace=True)
        results = results.dropna()
        #results['file'] = filename
        #results['shifttime']=results['time_post']-results['time_pre']
        return (results)
