#  Copyright (c) 2019 Jeorme Douay <jerome@far-out.biz>
#  MIT Liecnce, see the licence file for more information.

from pyPowerTrain.measurement import Measurement

class Strategy():

    name = 'strategy'
    conf=dict()
    conf['vehicles'] = list()

    def __init__(self, conf, storage):
        self.conf['data'] = "data"
        super().__init__()
        self.measurement = Measurement()
        self.conf.update(conf)
        self.storage=storage

    def Value(self, name, X=None, Y=None, Z=None):
        return self.storage.Value(name, X, Y, Z)

    def Process(self):
        '''
        Processing class, should be overwritten
        :return:
        '''
        pass

    def Evaluate(self):
        '''
        Processing class, should be overwritten
        :return:
        '''
        pass